Table of Contents

## Name

XtPopdown, XtCallbackPopdown - unmap a pop-up

## Syntax

void XtPopdown(Widget popup_shell);
void XtCallbackPopdown(Widget w, XtPointer client_data, XtPointer
  call_data);
void MenuPopdown(String shell_name);

## Arguments

call_data
  Specifies the callback data, which is not used by this procedure.
client_data
  Specifies a pointer to the XtPopdownID structure.
popup_shell
  Specifies the widget shell to pop down.
shell_name
  Specifies the name of the widget shell to pop down.
w
  Specifies the widget.

## Description

The XtPopdown function performs the following:

- Calls XtCheckSubclass Shell.
- Checks that popup_shell is currently popped_up; otherwise, it generates an error.
- Unmaps popup_shell's window.
- If popup_shell's grab_kind is either XtGrabNonexclusive or XtGrabExclusive, it calls XtRemoveGrab.
- Sets pop-up shell's popped_up field to False.
- Calls the callback procedures on the shell's popdown_callback list.

The XtCallbackPopdown function casts the client data parameter to an XtPopdownID pointer:

    0>=40 .vs 0u
    0<=39 .vs 0p
    typedef struct {
        Widget shell_widget;
        Widget enable_widget;
    } XtPopdownIDRec, *XtPopdownID;

The shell_widget is the pop-up shell to pop down, and the enable_widget is the widget that was used to pop it up.

XtCallbackPopdown calls XtPopdown with the specified shell_widget and then calls XtSetSensitive to resensitize the enable_widget.

If a shell name is not given, MenuPopdown calls XtPopdown with the widget for which the translation is specified. If a shell_name is specified in the translation table, MenuPopdown tries to find the shell by looking up the widget tree starting at the parent of the widget in which it is invoked. If it finds a shell with the specified name in the pop-up children of that parent, it pops down the shell; otherwise, it moves up the parent chain as needed. If MenuPopdown gets to the application top-level shell widget and cannot find a matching shell, it generates an error.

## See Also

XtCreatePopupShell(3Xt) , XtPopup(3Xt)
X Toolkit Intrinsics - C Language Interface
Xlib - C Language X Interface

Table of Contents

- Name
- Syntax
- Arguments
- Description
- See Also